#include<bits/stdc++.h>
using namespace std;
int32_t main(){
	int n,q;
	cin>>n>>q;
	long long a[n];
	for(int i=0;i<n;i++){
		cin>>a[i];
	}
	sort(a,a+n);
	long long g=0;
	for(int i=1;i<n;i++){
		a[i]-=a[0];
		g=__gcd(a[i],g);
	}
	while(q--){
		int x;
		cin>>x;
		a[0]+=x;
		cout<<__gcd(a[0],g)<<"\n";
	}
}